commit c04b0f63243d4d474daa66f84874ebf6b9e7b0cd
Author: Jonathan Wakely <jwakely@redhat.com>
Date:   Tue Apr 20 17:16:13 2021

    libstdc++: Do not allocate a zero-size vector<bool> [PR 100153]
    
    The vector<bool>::shrink_to_fit() implementation will allocate new
    storage even if the vector is empty. That then leads to the
    end-of-storage pointer being non-null and equal to the _M_start._M_p
    pointer, which means that _M_end_addr() has undefined behaviour.
    
    The fix is to stop doing a useless zero-sized allocation in
    shrink_to_fit(), so that _M_start._M_p and _M_end_of_storage are both
    null after an empty vector shrinks.
    
    Signed-off-by: Jonathan Wakely <jwakely@redhat.com>
    
    libstdc++-v3/ChangeLog:
    
            PR libstdc++/100153
            * include/bits/vector.tcc (vector<bool>::_M_shrink_to_fit()):
            When size() is zero just deallocate and reset.
    
    (cherry picked from commit 681707ec28d56494fa61a80c62500724d55f8586)

diff --git a/libstdc++-v3/include/bits/vector.tcc b/libstdc++-v3/include/bits/vector.tcc
index 8a6a99fb537..359997f2d9a 100644
--- a/libstdc++-v3/include/bits/vector.tcc
+++ b/libstdc++-v3/include/bits/vector.tcc
@@ -944,7 +944,13 @@ _GLIBCXX_BEGIN_NAMESPACE_CONTAINER
 	return false;
       __try
 	{
-	  _M_reallocate(size());
+	  if (size_type __n = size())
+	    _M_reallocate(__n);
+	  else
+	    {
+	      this->_M_deallocate();
+	      this->_M_impl._M_reset();
+	    }
 	  return true;
 	}
       __catch(...)

